Home | All Classes | Main Classes | Annotated | Grouped Classes | Functions |

# QCopChannel Class Reference

The QCopChannel class provides communication capabilities between several clients. More...

    #include <QCopChannel>

Inherits QObject.

- List of all members, including inherited members

### Writable Properties

- 1 writable property inherited from QObject

### Public Functions

- QCopChannel ( const QByteArray & channel, QObject * parent = 0 )
- QCopChannel ( const QByteArray & channel, QObject * parent, const char * name )
- virtual ~QCopChannel ()
- QByteArray channel () const
- virtual void receive ( const QByteArray & msg, const QByteArray & data )

- 24 public functions inherited from QObject

### Public Slots

- 1 public slot inherited from QObject

### Signals

- void received ( const QByteArray & msg, const QByteArray & data )

- 1 signal inherited from QObject

### Static Public Members

- bool isRegistered ( const QByteArray & channel )
- bool send ( const QByteArray & channel, const QByteArray & msg, const QByteArray & data )
- bool send ( const QByteArray & channel, const QByteArray & msg )

- 4 static public members inherited from QObject

### Protected Functions

- 9 protected functions inherited from QObject

## Detailed Description

The QCopChannel class provides communication capabilities between several clients.

The Qt Cop (QCOP) is a COmmunication Protocol, allowing clients to communicate both within the same address space and between different processes.

Currently, this facility is only available on Qt/Embedded. On X11 and Windows we are exploring the use of existing standards such as DCOP and COM.

QCopChannel provides send() and isRegistered() which are static functions usable without an object.

The channel() function returns the name of the channel.

In order to listen to the traffic on a channel, you should either subclass QCopChannel and reimplement receive(), or connect() to the received() signal.

## Member Function Documentation

### QCopChannel::QCopChannel ( const QByteArray & channel, QObject * parent = 0 )

Constructs a QCop channel and registers it with the server using the name channel. The standard parent argument is passed on to the QObject constructor.

### QCopChannel::QCopChannel ( const QByteArray & channel, QObject * parent, const char * name )

Use the two argument overload, and call setObjectName() to name the instance, instead.

### QCopChannel::~QCopChannel () `[virtual]`

Destroys the client's end of the channel and notifies the server that the client has closed its connection. The server will keep the channel open until the last registered client detaches.

### QByteArray QCopChannel::channel () const

Returns the name of the channel.

### bool QCopChannel::isRegistered ( const QByteArray & channel ) `[static]`

Queries the server for the existence of channel.

Returns true if channel is registered; otherwise returns false.

### void QCopChannel::receive ( const QByteArray & msg, const QByteArray & data ) `[virtual]`

This virtual function allows subclasses of QCopChannel to process data received from their channel.

The default implementation emits the received() signal.

Note that the format of data has to be well defined in order to extract the information it contains.

Example:

        void MyClass::receive(const QByteArray &msg, const QByteArray &data)
        {
            QDataStream stream(data, IO_ReadOnly);
            if (msg == "execute(QString,QString)") {
                QString cmd, arg;
                stream >> cmd >> arg;
                ...
            } else if (msg == "delete(QString)") {
                QString filenname;
                stream >> filename;
                ...
            } else ...
        }

This example assumes that the msg is a DCOP-style function signature and the data contains the function's arguments. (See send().)

Using the DCOP convention is a recommendation, but not a requirement. Whatever convention you use the sender and receiver must agree on the argument types.

See also send().

### void QCopChannel::received ( const QByteArray & msg, const QByteArray & data ) `[signal]`

This signal is emitted with the msg and data whenever the receive() function gets incoming data.

### bool QCopChannel::send ( const QByteArray & channel, const QByteArray & msg, const QByteArray & data ) `[static]`

Send the message msg on channel channel with data data. The message will be distributed to all clients subscribed to the channel.

Note that QDataStream provides a convenient way to fill the byte array with auxiliary data.

Example:

        QByteArray ba;
        QDataStream stream(ba, IO_WriteOnly);
        stream << QString("cat") << QString("file.txt");
        QCopChannel::send("System/Shell", "execute(QString,QString)", ba);

Here the channel is "System/Shell". The msg is an arbitrary string, but in the example we've used the DCOP convention of passing a function signature. Such a signature is formatted as functionname(types) where types is a list of zero or more comma-separated type names, with no whitespace, no consts and no pointer or reference marks, i.e. no "*" or "&".

Using the DCOP convention is a recommendation, but not a requirement. Whatever convention you use the sender and receiver must agree on the argument types.

See also receive().

### bool QCopChannel::send ( const QByteArray & channel, const QByteArray & msg ) `[static]`

This is an overloaded member function, provided for convenience. It behaves essentially like the above function.

Send the message msg on channel channel. The message will be distributed to all clients subscribed to the channel.

See also receive().